<!-- car  购物车 -->
<template  >
  <div class="carBox" ref="mainBox">
    <div class="flex flex-m car-item " v-for="(item , index ) in list" :key="item.id">
      <van-checkbox class="mr10" @click="checkItem" :checked-color="m_color" v-model="item.check"></van-checkbox>
      <div class="flex-1 flex">
        <van-image class="" width="1.5rem" height="1.5rem" fit="cover" :src="item.images|img" />
        <div class="flex-1 ml10">
          <div class="flex flex-m">
            <div @click="gogoodsDetils(item)" class="flex-1 rowHide2 goodsList-title">{{item.title}}</div>
            <div class="pl5" @click="delGoods(item,index)">
              <van-icon name="delete" />
            </div>
          </div>

          <div class="flex flex-b flex-m mt15 ">
            <div class="flex-1 oh">
               <div class="goodsList-price">¥{{item.price}}</div>
                <div class="goods-lable oneShow">{{item.option_name | replaceStr}}</div>
             </div>
           
            <van-stepper  @plus="stepperChange(item)" @blur="stepperChange(item)" @minus="stepperChange(item,1)" v-model="item.num" input-width="40px" button-size="23px" />
          </div>
        </div>
      </div>

    </div>
    <van-submit-bar :price="getTotal()*100" button-text="结算" @submit="onSubmit">
      <van-checkbox @click="handelAllcheck" class="pl5" :checked-color="m_color" v-model="checked">全选</van-checkbox>
      <div @click="goods_cart_flush" class="ml20 m_gray1">清空</div>
    </van-submit-bar>
    <div class="noListPic" v-if="!list.length">
      <img src="@/assets/img/nogoods.png">
      <div>您的购物车中没有商品哦！</div>
      <div @click="$router.push('/index/mall')" class="btn-o-small mt10">去商场逛逛吧</div>
    </div>
  </div>
</template>

<script>

export default {
  name: 'car',
  data() {
    return {
      list: [],
      checked: false,
      checkTime: null, //计算全选 定时器
      updateTime: null, // 编辑数量 定时器
      contentBoxTop: 0,
      checkList:[],
    }
  },

  beforeRouteLeave(to, form, next) {
    this.contentBoxTop = document.getElementById('main_box_1').scrollTop
    next()
  },

  activated() {
    document.getElementById('main_box_1').scrollTop = this.contentBoxTop
    this.init()

  },

  deactivated(){
    this.checkList = this.list.filter(i => i.check).map(i=>i.id)

  },

  created() {
    this.m_loading()
  },

  methods: {
    //初始化方法
    init() {
      this.getDataList()
      

    },
    getDataList() {
      this.api.goods_cart().then(res => {
        this.list = res.data.map(i => {
          i.check = this.checkList.includes(i.id)
          return i
        })
        this.checkItem()
        this.m_hideLoading()
      })
    },

    getTotal() {
      let items = this.list.filter(i => i.check)
      let sum = 0
      items.forEach(i => {
        let price = this.isNaN0(i.price) * this.isNaN0(i.num)
        sum = sum + price
      })

      return sum
    },



    handelAllcheck() {
      this.$nextTick(() => {
        let check = this.checked
        this.list.forEach(i => {
          i.check = !check
        })
      })
    },

    checkItem() {
      this.checkTime = clearTimeout(this.checkTime)
      this.checkTime = setTimeout(() => {
        let len = this.list.length
        let checkLen = this.list.filter(i => i.check).length
        this.checked = len == checkLen && len > 0
      }, 150)
    },

    stepperChange(item, v) {
      if (v) {
        this.goods_cart_update(item)
        return
      }
      this.updateTime = clearTimeout(this.updateTime)
      this.updateTime = setTimeout(() => {
        this.goods_cart_update(item)
      }, 500)
    },

    goods_cart_update(item) {
      let data = { id: item.id, num: item.num }
      this.m_loading()
      this.api.goods_cart_update(data).then(res => {
        this.m_hideLoading()
      }).catch(err=>{
        this.m_loading
        this.getDataList()
      })


    },

    //清空购物车
    goods_cart_flush() {
      this.$dialog.confirm({
        title: '清空提示',
        message: '是否确认清空购物车?'
      }).then(res => {
        this.m_loading()
        this.api.goods_cart_flush().then(res => {
          this.m_hideLoading()
          this.getDataList()
        })
      }).catch(res => {

      })
    },

    //删除商品
    delGoods(item, index) {
      this.$dialog.confirm({
        title: '删除提示',
        message: '是否确认将商品从购物车删除?'
      }).then(res => {
        this.m_loading()
        this.api.goods_cart_delete({ id: item.id }).then(res => {
          this.m_hideLoading()
          this.list.splice(index, 1)
          this.checkItem()
        })
      }).catch(res => {

      })


    },

    gogoodsDetils(item) {
      this.$router.push(`/goodsDetail?id=${item.goods_id}`)
    },


    onSubmit() {
      let items = this.list.filter(i => i.check)
      if (!items.length) {
        this.m_toast('请选择商品')
        return
      }
      let goods = items.map(i => {
        let item = {
          goods_id: i.goods_id,
          cart_id: i.id,
          num: i.num,
          price: i.price,
          images: i.images,
          option_id: i.option_id || '0',
          title:i.title,
          unit:i.unit,
          total: this.isNaN0(i.num) * this.isNaN0(i.price),
          option_name:i.option_name
        }
        return item
      })

      let goods_price = this.getTotal()
      let orderItem = JSON.stringify({ goods, goods_price })
      sessionStorage.orderData = orderItem
      this.$router.push('/suerOrder')

    },
  },


}

</script>
<style  scoped>
</style>

<style lang='scss' >
.carBox {
  padding-bottom: 1rem;
  .van-submit-bar {
    z-index: 999;
    // bottom: 1.4rem;
    border-bottom: 1px solid #eee;
  }
}

.car-item {
  padding: 0.26rem;
  background: #fff;
}

.goodsList-title {
  font-size: 0.28rem;
  font-weight: bold;
}
.goodsList-price {
  color: #ff5555;
  font-size: 0.3rem;
}

.m_gray1 {
  color: #999;
}

.goods-lable{
  font-size: 0.26rem;
  margin-top: 0.05rem;
  color: #666;
}
</style>